using System;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;

namespace AdhiC.db
{
	
	public abstract class AdhiDBConnection
	{
		//the connection object to the database
		private Component connection;

        public Component Connection
        {
            get
            {
                return connection;
            }
            set
            {
                connection = value;
            }
        }
		//get the instance of a connection based on the dbtype defined
		//in the app.config
		public static AdhiDBConnection  getInstance()
		 {
		  return getInstance(
              ConfigurationManager.AppSettings[AdhiConstants.DB_TYPE]);
		 }
		
		//get the instance of a connection based on the dbtype
		public static AdhiDBConnection  getInstance(string dbType)
		{
			AdhiDBConnection conn = null; 
			
			if (AdhiConstants.MS_ACCESS.Equals(dbType))
				{
					conn = new AdhiOleDBConnection();
				}
            else if (AdhiConstants.SQL_SERVER.Equals(dbType))
				{
					conn = new AdhiSQLConnection();
				}
			else if (AdhiConstants.ODBC_DRIVER.Equals(dbType))
			{
				conn = new AdhiOdbcConnection();
			}
             return conn;
		}
		
		public abstract void setConnectionString(string connectionString);
        public abstract ConnectionState getState();
        public abstract void Open();
        public abstract void Close();
	}
}
